### Service(s) in the container

Two flavours of the _SEDModS_ service can run with the repo content:
 - one that reads the HDF5 at each query
 - one that reads the HDF5 once and works as a _system daemon_

#### Single query service mode
This mode is directly available when the cotainer is run. It uses the
following code files:

    wsgi.py
    hdf_query.py

If you run on the host server 

    curl localhost:8080/sedsearch/?'clump_mass<10.005' > output.dat

you should get the response in the `output.dat` file, or you can point
the browser to

    http://host.server:8080/sedsearch/?'clump_mass<10.005'

and see the response directly.

#### Daemon service mode
This mode uses the code in:

    wsgid.py
    query_server_d.py

It requires a couple of processes to run before the deamonised service
can work. These processes run within the container, so, after running
it, one can launch them attaching to the running container with

    podman exec -it sedmod-test /bin/bash

and within it run

    python -m Pyro4.naming &
		python query-server_d.py &

After that, on can exit the shell and the daemon-based service should be
reachable at

    http://host.server:8080/seddaemon

with the same usage of the single query one.

## SED Models HDF5 file
This is preserved, currently, on the INAF ICT Owncloud instance.

### Network Proxy
The service can be made visible on a specific context path in the host
server's http using the httpd _ProxyPass_ directive, like

    <Location "/sedmods">
        ProxyPass "http://localhost:8080"
    </Location>

where _/sedmods_ is an example and the _8080_ port depends on the passed
parameters to the podman run command (see above).

## Dependencies

On the host:
 - podman
 - httpd

Within the container (i.e. provided in the build):
 - httpd with python3-mod\_wsgi
 - python 3.x
 - pandas
 - Pyro4 (deamon mode)
 - (py)tables
